<?php

namespace Modules\Pp\Entities;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Support\Facades\Auth;
use Spatie\Activitylog\Contracts\Activity;
use Spatie\Activitylog\Traits\LogsActivity;
class MachinaryProduct extends Model
{
    protected $table = 'pp_machinery_product';
    protected $primaryKey = 'machinery_product_id';
    public $incrementing = false;
    use HasFactory,LogsActivity;
    protected static $logAttributes = [
        'machinery_product_id',
        'machinery_id',
        'product_Id',
        'quantity',
        'umo',
        'wastage',
        'status'
    ];
    protected static $logOnlyDirty = true;
    public function tapActivity(Activity $activity, string $eventName)
    {
        $activity->log_name = "pp_machinery_product";
        $activity->description = $eventName;
        $activity->causer_id = Auth::user()->id;
    }
}
