<?php

namespace Modules\Pp\Http\Controllers;

use Illuminate\Contracts\Support\Renderable;
use Illuminate\Http\Request;
use Illuminate\Routing\Controller;
use Illuminate\Support\Facades\DB;
use Modules\Pp\Entities\Machinary_Product;
use Modules\Pp\Entities\MachinaryProduct;
use Modules\Pp\Entities\Product;

class PpMachineryProductController extends Controller
{
    function loadProducts()
    {
        try {
            $Product = Product::where('product_type_id', 4)->select('product_name', 'product_primary_id')->get();

            $responseBody = $this->responseBody(true, "Products", "Found", $Product);
        } catch (\Exception $ex) {
            $responseBody = $this->responseBody(false, "Products", "error", $ex);
        }
        return response()->json(["data" => $responseBody]);
    }
    function save(Request $request)
    {
        try {
            $machinaryProduct = new MachinaryProduct();
            $machinaryProduct->machinery_id = $request->get('machine_id');
            $machinaryProduct->product_Id = $request->get('product_Id');
            $machinaryProduct->quantity = $request->get('quantity');
            $machinaryProduct->umo = $request->get('umo');
            $machinaryProduct->wastage = $request->get('wastage');

            $machinaryProduct->status = true;
            $result = $machinaryProduct->save();

            if ($result) {
                $responseBody = $this->responseBody(true, "machinary Product", "saved", $result);
            } else {
                $responseBody = $this->responseBody(false, " machinary Product", "error", null);
            }
        } catch (\Exception $ex) {
            $responseBody = $this->responseBody(false, " machinary", "error", $ex);
        }
        return response()->json(["data" => $responseBody]);
    }
    function alldata($id)
    {
        try {
            // $machinary=new Machinary();
            // $result=$machinary->all();
            $result = DB::table('pp_machinery_product')
                ->join('pp_machinery', 'pp_machinery.machinery_id', '=', 'pp_machinery_product.machinery_id')
                ->join('st_products', 'st_products.product_primary_id', '=', 'pp_machinery_product.product_Id')
                ->where('pp_machinery_product.machinery_id', '=', $id)
                ->select('pp_machinery_product.*', 'pp_machinery.machinery_name', 'st_products.product_name')->get();

            $responseBody = $this->responseBody(true, "machinery_product all", "found", $result);
        } catch (\Exception $ex) {
            $responseBody = $this->responseBody(false, " machinery_product", "error", $ex);
        }
        return response()->json(["data" => $responseBody]);
    }
    function disable(Request $request, $id)
    {
        try {
            $MachinaryProduct = MachinaryProduct::find($id);
            if ($MachinaryProduct) {
                $MachinaryProduct->status = $request->get('status');
                $MachinaryProduct->update();
            }


            $responseBody = $this->responseBody(true, "machinery_product status", "Sucess", $request->status);
        } catch (\Exception $ex) {
            $responseBody = $this->responseBody(false, " machinery_product status", "error", $ex);
        }
        return response()->json(["data" => $responseBody]);
    }
    function delete($id)
    {
        try {
            $MachinaryProduct = MachinaryProduct::where('machinery_product_id', $id)->delete();

            $responseBody = $this->responseBody(true, "machinery_product delete", "deleted", $MachinaryProduct);
        } catch (\Exception $ex) {
            $responseBody = $this->responseBody(false, " machinery_product delete", "error", $ex);
        }
        return response()->json(["data" => $responseBody]);
    }
    function edit($id)
    {
        try {
            $MachinaryProduct = MachinaryProduct::where('machinery_product_id', $id)->first();

            $responseBody = $this->responseBody(true, "MachinaryProduct edit data", "Sucess", $MachinaryProduct);
        } catch (\Exception $ex) {
            $responseBody = $this->responseBody(false, " MachinaryProduct edit data", "error", $ex);
        }
        return response()->json(["data" => $responseBody]);
    }
    function update(Request $request, $id)
    {
        try {
            $MachinaryProduct = MachinaryProduct::where('machinery_product_id', $id)
                ->update([
                    'machinery_id' => $request->get('machinery_id'),
                    'product_Id' => $request->get('product_Id'),
                    'quantity' => $request->get('quantity'),
                    'umo' => $request->get('umo'),
                    'wastage' => $request->get('wastage'),

                ]);

            if ($MachinaryProduct) {
                $responseBody = $this->responseBody(true, "MachinaryProduct", "updates", null);
            } else {
                $responseBody = $this->responseBody(false, " MachinaryProduct", "error", $request->Site_id);
            }
        } catch (\Exception $ex) {
            $responseBody = $this->responseBody(false, " machinary", "error", $ex);
        }
        return response()->json(["data" => $responseBody]);
    }




    function isAssignProductToMachine($machine_id, $product_id)
    {
        try {
            $bool = false;
            $machineProduct =  MachinaryProduct::where([['machinery_id', '=', $machine_id], ['product_id', '=', $product_id]])->first();
            if ($machineProduct) {
                $bool = true;
            }
            $responseBody = $this->responseBody(true, "quantityPerHour", "Found", $bool);
        } catch (\Exception $ex) {
            $responseBody = $this->responseBody(false, "quantityPerHour", "error", $ex);
        }
        return response()->json(["data" => $responseBody]);
    }


    function allMachineryProduct($machine_id)
    {
        try {
            $query = 'SELECT pp_machinery.machinery_name,st_products.product_id,st_products.product_name,pp_machinery_product.quantity,pp_machinery_product.status,pp_machinery_product.machinery_product_id FROM pp_machinery_product
            INNER JOIN pp_machinery ON pp_machinery_product.machinery_id = pp_machinery.machinery_id
            INNER JOIN st_products ON pp_machinery_product.product_Id = st_products.product_primary_id WHERE pp_machinery_product.machinery_id = "' . $machine_id . '"';
            $result =  DB::select($query);
            $responseBody = $this->responseBody(true, "quantityPerHour", "Found", $result);
        } catch (\Exception $ex) {
            $responseBody = $this->responseBody(false, "quantityPerHour", "error", $ex);
        }
        return response()->json(["data" => $responseBody]);
    }


    //responcebody
    private function responseBody($success, $name, $message, $result)
    {
        $body = [
            "success" => $success,
            "message" => $message,
            "name" => $name,
            "result" => $result
        ];
        return $body;
    }
}
